#include <stdio.h>
#include <stdlib.h>
#include "btree.h"

struct node *btree_insert(struct node *n, int value) {
  if (n) {
	if (n->value > value) {
	  n->l = btree_insert(n->l, value);
	}
	else {
	  n->r = btree_insert(n->r, value);
	}
  }
  else {
	if (!(n = calloc(1, sizeof(struct node)))) {
	  return NULL;
	}
	n->value = value;
	/* Con la funzione 'calloc' non e' necessario: */
	/* n->l = n->r = NULL */
  }

  return n;
}

void btree_depth_visit(struct node *n) {
  if (n) {
	btree_depth_visit(n->l);
	printf("%d\n", n->value);
	btree_depth_visit(n->r);
  }
}

void btree_dispose(struct node *n) {
  if (n) {
	btree_dispose(n->l);
	btree_dispose(n->r);
	free(n);
  }
}
