#include <stdio.h>
#include <stdlib.h>
#include "matrix.h"

#define PRINT_HELP printf("Uso: %s <#righe> <#colonne>\n", argv[0]);
#define UNSORTED "Matrice non-ordinata"
#define SORTED "Matrice ordinata"

int main (int argc, char **argv) {
  matrix m;

  if (argc == 3) {
	m.rows = atoi(argv[1]);
	m.cols = atoi(argv[2]);
	if (m.rows <= 0 || m.cols <= 0) {
	  PRINT_HELP;
	  return 1;
	}
	if (matrix_generate(&m) || matrix_populate(&m)) {
	  return 1;
	}
	matrix_print(&m, UNSORTED);
	matrix_sort(&m);
	matrix_print(&m, SORTED);
	return matrix_dispose(&m);
  }

  PRINT_HELP;
  return 1;
}
